/* Part 2 of library code that uses nested function.  */

#include <stddef.h>

extern void traverse_array (void **array, unsigned int size, void (*func)(void* /*element*/));

unsigned int count_nonnull_entries (void **array, unsigned int size)
{
  int count = 0;

  void increment_count (void* element)
  {
    if (element != NULL)
      count++;
  }

  traverse_array (array, size, increment_count);

  return count;
}
