/* Test invocation of a nested function in the main thread.  */

#include <stdio.h>

extern void debug_info (void);
extern unsigned int count_nonnull_entries (void **array, unsigned int size);

int
main ()
{
  void *array[5] = { "abc", NULL, "def", "rst", NULL };

  debug_info ();

  unsigned int count = count_nonnull_entries (array, 5);
  printf ("count = %u\n", count);
}

/*
 * Local Variables:
 * compile-command: "gcc -Wall nested-in-main.c nested1.c nested2.c debug.c"
 * End:
 */
